package org.goya.server.dynamic.dao;

import org.goya.server.dynamic.model.*;

import javax.ejb.*;
import javax.persistence.*;
import java.util.Collection;

@Stateless
public class MetaModelDAOBean implements MetaModelDAO {

    @PersistenceContext(name = "goyaDatabase")
    private EntityManager em;

    public void makePersistent(MetaType metaType) {
        em.persist(metaType);
    }

    public void makeTransient(MetaType metaType) {
        // TODO: This doesn't work, needs to remove all item/values too
        em.remove(metaType);
    }

    public MetaType findMetaTypeByName(String name) {
        return (MetaType)em.createQuery("from MetaType mt where mt.name = :name")
                .setParameter("name", name)
                .getSingleResult();
    }

    public void makePersistent(Item item) {
        em.persist(item);
    }

    public void makeTransient(Item item) {
        // TODO: This doesn't work, needs to remove all attributevalues too
        em.remove(item);
    }

    public Collection findItemsByMetaType(MetaType metaType) {
        return em.createQuery("from Item i where i.metaType = :metaType")
                .setParameter("metaType", metaType)
                .getResultList();
    }

    public Collection findItemsByAttributeValue(MetaAttributeType attributeType, Object attributeValue) {
        String propertyName = attributeType.name();
        Query q = em.createQuery("from Item i join i.attributeValues aV where aV.value." + propertyName + " = :v");
        q.setParameter("v", attributeValue);
        return q.getResultList();
    }

    public Collection findItemsByAttribute(MetaAttribute attribute) {
        Query q = em.createQuery("from Item i join i.attributeValues aV where aV.metaAttribute = :a");
        q.setParameter("a", attribute);
        return q.getResultList();
    }
}
