package org.goya.server.dynamic.model;

import org.hibernate.annotations.TypeDefs;
import org.hibernate.annotations.TypeDef;
import org.goya.server.dynamic.dao.AttributeValueHibernate;
import org.goya.server.core.model.BusinessEntity;

import javax.persistence.*;

@TypeDefs({
    @TypeDef(name="attribute_value_usertype", typeClass = AttributeValueHibernate.class)
})
@Entity(access = AccessType.FIELD)
@Table(name = "META_ATTRIBUTE_VALUES")
public class AttributeValue extends BusinessEntity {

    @ManyToOne
    @JoinColumn(name = "ITEM_ID", nullable = false, updatable = false)
    private Item item;

    @ManyToOne
    @JoinColumn(name = "META_ATTRIBUTE_ID", nullable = false, updatable = false)
    private MetaAttribute metaAttribute;

    @org.hibernate.annotations.Type(type = "attribute_value_usertype")
    @org.hibernate.annotations.Columns(
        columns = {
            @Column( name="INT_VALUE"),
            @Column( name="DOUBLE_VALUE"),
            @Column( name="DATETIME_VALUE"),
            @Column( name="STRING_VALUE")
        }
	)
    private Object value;

    public AttributeValue() {}

    AttributeValue(Item item, MetaAttribute metaAttribute, Object value) {
        this.item = item;
        this.metaAttribute = metaAttribute;
        this.value = value;
    }

    public Item getItem() {
        return item;
    }

    public MetaAttribute getAttribute() {
        return metaAttribute;
    }

    public Object getValue() {
        return value;
    }

    public void setValue(Object value) {
        this.value = value;
    }
}
