package org.goya.server.dynamic.model;

import org.goya.server.core.model.BusinessEntity;

import javax.persistence.*;
import java.util.Set;
import java.util.HashSet;

@Entity(access = AccessType.FIELD)
@Table(name = "META_ITEMS")
public class Item extends BusinessEntity {

    @ManyToOne
    @JoinColumn(name = "META_TYPE_ID", nullable = false, updatable = false)
    private MetaType metaType;

    @OneToMany(mappedBy = "item", cascade = CascadeType.PERSIST)
    private Set<AttributeValue> attributeValues = new HashSet<AttributeValue>();

    public Item() {}

    public Item(MetaType metaType) {
        this.metaType = metaType;
    }

    public MetaType getMetaType() {
        return metaType;
    }

    public Set<AttributeValue> getAttributeValues() {
        return attributeValues;
    }

    public void setAttributeValues(Set<AttributeValue> attributeValues) {
        this.attributeValues = attributeValues;
    }

    /* ################################################################# */

    public AttributeValue addAttributeValue(MetaAttribute attribute, Object value) {
        AttributeValue attributeValue = new AttributeValue(this, attribute, value);
        getAttributeValues().add(attributeValue);
        return attributeValue;
    }

    public AttributeValue addAttributeValue(String attributeName, Object value) {
        MetaAttribute attribute = getMetaType().getAttributes().get(attributeName);
        return addAttributeValue(attribute, value);
    }
}
