package org.goya.server.dynamic.model;

import org.goya.server.core.model.BusinessEntity;

import javax.persistence.*;

@Entity(access = AccessType.FIELD)
@Table(name = "META_ATTRIBUTES",
       uniqueConstraints =
        {@UniqueConstraint(columnNames =
            {"ATTR_NAME", "META_TYPE_ID"} )
        }
    )
public class MetaAttribute extends BusinessEntity {

    @Column(name = "ATTR_NAME", length = 20, nullable = false)
    private String name;

    @Column(name = "ATTR_DESCRIPTION", length = 100, nullable = false)
    private String description;

    @ManyToOne
    @JoinColumn(name = "META_TYPE_ID", nullable = false, updatable = false)
    private MetaType metaType;

    // Force string representation of the enum value
    @Column(name = "META_ATTRIBUTE_TYPE", nullable = false, updatable = false, columnDefinition = "VARCHAR(15)")
    private MetaAttributeType attributeType;

    public MetaAttribute() {}

    MetaAttribute(MetaType metaType, MetaAttributeType attributeType, String name, String description) {
        this.metaType = metaType;
        this.attributeType = attributeType;
        this.name = name;
        this.description = description;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public MetaType getMetaType() {
        return metaType;
    }

    public MetaAttributeType getAttributeType() {
        return attributeType;
    }

}
