package org.goya.server.dynamic.model;

import org.goya.server.core.model.BusinessEntity;

import javax.persistence.*;
import java.util.*;

@Entity(access = AccessType.FIELD)
@Table(name = "META_TYPES")
public class MetaType extends BusinessEntity {

    @Column(name = "META_TYPE_NAME", length = 20, nullable = false, unique = true)
    private String name;

    @Column(name = "META_TYPE_DESCRIPTION", length = 100, nullable = false)
    private String description;

    @MapKey(name = "name")
    @OneToMany(mappedBy = "metaType", cascade = CascadeType.PERSIST)
    private Map<String, MetaAttribute> attributes = new HashMap<String, MetaAttribute>();

    public MetaType() {}

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Map<String, MetaAttribute> getAttributes() {
        return attributes;
    }

    public void setAttributes(Map<String, MetaAttribute> attributes) {
        this.attributes = attributes;
    }

    /* ################################################################# */

    public MetaAttribute addAttribute(MetaAttributeType attributeType, String name, String description) {
        MetaAttribute attribute =
                new MetaAttribute(this, attributeType, name, description);
        getAttributes().put(name, attribute);
        return attribute;
    }

    public MetaAttribute removeAttribute(String name) {
        return getAttributes().remove(name);
    }

}
